import { Operand } from '3xpr';
import { EntityMapping, Field, Sentence, Join, Map, Filter, GroupBy, Having, Insert } from 'lambdaorm-base';
import { Query } from '../../../../query/domain';
import { DmlBuilderAdapter } from '../base/dmlBuilder';
export declare class NoSqlDMLBuilderAdapter extends DmlBuilderAdapter {
    build(sentence: Sentence): Query;
    protected buildSelectSentence(sentence: Sentence): string;
    private addAggregate;
    protected buildReplaceRoot(entity: EntityMapping): string;
    protected buildDeleteSentence(sentence: Sentence): string;
    protected getHaving(groupByStringClause: string, having: Having): string;
    protected solveHaving(operand: Operand, groupKeyValues: [string, string][], toReplaces: [string, string][]): void;
    protected normalizeEqual(a: string, b: string): boolean;
    protected getGroupBy(map: Map, _groupBy: GroupBy, sentence: Sentence): string;
    protected getMap(map: Map, sentence: Sentence): any;
    protected getComposite(sentence: Sentence): string | undefined;
    protected getChildrenMap(sentence: Sentence): any;
    protected buildJoins(entity: EntityMapping, joins: Join[]): string;
    protected buildFilter(operand: Filter): string;
    protected getFieldMapping(operand: Field, alias?: string): string;
    protected buildInsert(operand: Insert, entity: EntityMapping): string;
    protected buildUpdateSentence(sentence: Sentence): string;
    protected buildUpdate(sentence: Sentence): string;
    protected buildField(operand: Field): string;
    protected buildObject(operand: Operand): string;
    protected setPrefixToField(operand: Operand, prefix: string): void;
    protected hadGroupFunction(operand: Operand): boolean;
}
